package sun.security.provider.certpath.ldap;

import javax.naming.CommunicationException;
import javax.naming.ServiceUnavailableException;
import java.security.cert.CertStoreException;
import java.util.Collection;
import java.security.cert.X509CRLSelector;
import java.io.IOException;
import javax.security.auth.x500.X500Principal;
import java.security.cert.X509CertSelector;
import java.security.InvalidAlgorithmParameterException;
import java.security.NoSuchAlgorithmException;
import java.security.cert.CertStore;
import java.net.URI;
import sun.security.provider.certpath.CertStoreHelper;

public final class LDAPCertStoreHelper extends CertStoreHelper
{
    public LDAPCertStoreHelper() {
    }
    
    public CertStore getCertStore(URI uri) throws NoSuchAlgorithmException, InvalidAlgorithmParameterException {
        return LDAPCertStore.getInstance(LDAPCertStore.getParameters(uri));
    }
    
    public X509CertSelector wrap(X509CertSelector x509CertSelector, X500Principal x500Principal, String s) throws IOException {
        return new LDAPCertStore.LDAPCertSelector(x509CertSelector, x500Principal, s);
    }
    
    public X509CRLSelector wrap(X509CRLSelector x509CRLSelector, Collection<X500Principal> collection, String s) throws IOException {
        return new LDAPCertStore.LDAPCRLSelector(x509CRLSelector, collection, s);
    }
    
    public boolean isCausedByNetworkIssue(CertStoreException ex) {
        Throwable cause = ex.getCause();
        return cause != null && (cause instanceof ServiceUnavailableException || cause instanceof CommunicationException);
    }
}
